unit UnitMain;

interface

uses
  Classes, SysUtils, QDialogs, QMenus, QTypes, QCheckLst, QStdCtrls, QComCtrls,
  QExtCtrls, QControls,  QForms,
  QrsPropSaver, QrsProperties, QrsStorage, QrsIniData, QrsUtils;


type
  TFormMain = class(TForm)
    MainMenu: TMainMenu;
    miFile: TMenuItem;
    miHelp: TMenuItem;
    miAbout: TMenuItem;
    miExit: TMenuItem;
    pcMain: TPageControl;
    tsNoProgramming: TTabSheet;
    tsCustomProps: TTabSheet;
    rsStorage1: TrsStorage;
    rsIniData1: TrsIniData;
    rsPropSaver1: TrsPropSaver;
    rsCustomProperties1: TrsCustomProperties;
    Memo1: TMemo;
    Splitter1: TSplitter;
    Panel1: TPanel;
    Panel2: TPanel;
    Label1: TLabel;
    btnMemoColor: TButton;
    btnMemoFont: TButton;
    ColorDialog1: TColorDialog;
    FontDialog1: TFontDialog;
    Panel4: TPanel;
    Edit1: TEdit;
    Panel5: TPanel;
    Label4: TLabel;
    CheckBox1: TCheckBox;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    Panel6: TPanel;
    Label5: TLabel;
    Image1: TImage;
    Button1: TButton;
    Panel8: TPanel;
    Label7: TLabel;
    HeaderControl1: THeaderControl;
    Panel9: TPanel;
    tsLittleProgramming: TTabSheet;
    Panel10: TPanel;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    ListBox1: TListBox;
    Label8: TLabel;
    Memo2: TMemo;
    Label9: TLabel;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    rsPropSaver2: TrsPropSaver;
    Label10: TLabel;
    ListBox2: TListBox;
    ListBox3: TListBox;
    Button5: TButton;
    Memo3: TMemo;
    CheckListBox1: TCheckListBox;
    Label3: TLabel;
    btnManualPrograming: TButton;
    tsEncrypt: TTabSheet;
    Memo4: TMemo;
    edEncrypt: TEdit;
    Label2: TLabel;
    OPDialog1: TOpenDialog;
    procedure miExitClick(Sender: TObject);
    procedure miAboutClick(Sender: TObject);
    procedure btnMemoFontClick(Sender: TObject);
    procedure btnMemoColorClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure rsCustomProperties1Properties0GetProperty(Sender,
      Instance: TObject; var Value: Variant);
    procedure rsCustomProperties1Properties0SetProperty(Sender,
      Instance: TObject; var Value: Variant);
    procedure rsCustomProperties1Properties1GetProperty(Sender,
      Instance: TObject; var Value: Variant);
    procedure rsCustomProperties1Properties1SetProperty(Sender,
      Instance: TObject; var Value: Variant);
    procedure Button5Click(Sender: TObject);
    procedure rsPropSaver2AfterLoad(Sender: TObject);
    procedure rsPropSaver2BeforeSave(Sender: TObject);
    procedure btnManualProgramingClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    function  GetListBoxChecks(Instance: TCheckListBox): string;
    procedure SetListBoxChecks(Instance: TCheckListBox; const Value: string);
  end;

var
  FormMain: TFormMain;

implementation

{$R *.XFM}

procedure TFormMain.miExitClick(Sender: TObject);
begin
  Close;
end;


procedure TFormMain.miAboutClick(Sender: TObject);
begin
// Load and run "About Storage library" dialog.
  RslAbout;
end;

procedure TFormMain.btnMemoFontClick(Sender: TObject);
begin
  FontDialog1.Font.Assign(Memo1.Font);
  if FontDialog1.Execute then Memo1.Font.Assign(FontDialog1.Font);
end;

procedure TFormMain.btnMemoColorClick(Sender: TObject);
begin
  ColorDialog1.Color := Memo1.Color;
  if ColorDialog1.Execute then Memo1.Color := ColorDialog1.Color;
end;

procedure TFormMain.Button1Click(Sender: TObject);
begin
  if OPDialog1.Execute then Image1.Picture.LoadFromFile(OPDialog1.FileName);
end;

procedure TFormMain.Button2Click(Sender: TObject);
begin
  FontDialog1.Font.Assign(ListBox1.Font);
  if FontDialog1.Execute then ListBox1.Font.Assign(FontDialog1.Font);
end;

procedure TFormMain.Button3Click(Sender: TObject);
var
  s: string;
begin
  s := 'Item '+IntToStr(ListBox1.Items.Count+1);
  if InputQuery('Add Item to ListBox','Input Item', s) then
    ListBox1.Items.Add(s);
end;

procedure TFormMain.Button4Click(Sender: TObject);
var
  s: string;
  i: integer;
begin
  s := IntToStr(ListBox1.Items.Count-1);
  if InputQuery('Delete Item from ListBox', 'Item Index (0..Count-1)', s) then begin
    i := StrToInt(s);
    if (i>=0) and (i<ListBox1.Items.Count) then ListBox1.Items.Delete(i);
  end;
end;

procedure TFormMain.rsCustomProperties1Properties0GetProperty(Sender,
  Instance: TObject; var Value: Variant);
begin
  Value := (Instance as TComboBox).ItemIndex;
end;

procedure TFormMain.rsCustomProperties1Properties0SetProperty(Sender,
  Instance: TObject; var Value: Variant);
begin
  with (Instance as TComboBox) do
    if (Value>=0) and (Value<Items.Count) then begin
      ItemIndex := Value;
      if Style=csDropDown then Text := Items[ItemIndex];
    end;
end;

procedure TFormMain.rsCustomProperties1Properties1GetProperty(Sender,
  Instance: TObject; var Value: Variant);
begin
  Value := (Instance as TCustomListBox).ItemIndex;
end;

procedure TFormMain.rsCustomProperties1Properties1SetProperty(Sender,
  Instance: TObject; var Value: Variant);
begin
  (Instance as TCustomListBox).ItemIndex := Value;
end;

procedure TFormMain.Button5Click(Sender: TObject);
begin
  ColorDialog1.Color := ListBox1.Color;
  if ColorDialog1.Execute then ListBox1.Color := ColorDialog1.Color;
end;

procedure TFormMain.rsPropSaver2AfterLoad(Sender: TObject);
begin
  SetListBoxChecks(CheckListBox1, rsPropSaver2.Values['CheckListBox1']);
end;

procedure TFormMain.rsPropSaver2BeforeSave(Sender: TObject);
begin
  rsPropSaver2.Values['CheckListBox1'] := GetListBoxChecks(CheckListBox1);
end;

function TFormMain.GetListBoxChecks(Instance: TCheckListBox): string;
var
  i,k: integer;
begin
  SetLength(Result, Instance.Items.Count*2);
  k := 1;
  for i:=0 to Instance.Items.Count-1 do begin
    if Instance.Checked[i] then Result[k] := '1'
     else Result[k] := '0';
    Result[k+1] := ',';
    Inc(k,2);
  end;
  if Length(Result)>0 then SetLength(Result, Length(Result)-1);
end;

procedure TFormMain.SetListBoxChecks(Instance: TCheckListBox; const Value: string);
var
  i: integer;
begin
  for i:=0 to Instance.Items.Count-1 do
    Instance.Checked[i] := (Length(Value)>=(i*2+1)) and (Value[i*2+1]='1');
end;

procedure TFormMain.btnManualProgramingClick(Sender: TObject);
begin
// manual programming

// It is three methods of work with TrsStorage keys.
 rsStorage1.WriteInteger('\Manual\Value1', 7);
 rsStorage1.Values['\Manual\Value2'] := 7;
 rsStorage1['\Manual\Value3'] := 7;

 rsStorage1.KeyDelete('\Manual\Value1');
 if rsStorage1.KeyExist('\Manual\Value1') then ShowMessage('Key not deleted.');

// group operation in the one section more faster.
// set rsStorage.RootSection for this.
 rsStorage1.RootSection := 'Manual';
 rsStorage1['IntegerValue'] := 7;
 rsStorage1['StringValue'] := 'sample string';
 rsStorage1.WriteComponent('ComponentAtAll', btnManualPrograming);
 rsStorage1['SubSection\TodayDate'] := date;

// look on result in the ini file. 
end;

end.
