unit UMain;

interface

uses
  Classes, SysUtils, QForms, QMenus, QTypes, QControls, QStdCtrls,
  QrsStorage, QrsIniData, QrsPropSaver, QrsUtils;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    miFile: TMenuItem;
    miSeparator: TMenuItem;
    miExit: TMenuItem;
    miHelp: TMenuItem;
    miAbout: TMenuItem;
    rsStorage1: TrsStorage;
    rsPropSaver1: TrsPropSaver;
    rsIniData1: TrsIniData;
    Memo1: TMemo;
    procedure miAboutClick(Sender: TObject);
    procedure rsIniData1SaveToStream(Stream: TStream;
      var DoStandard: Boolean);
    procedure rsIniData1LoadFromStream(Stream: TStream;
      var DoStandard: Boolean);
    procedure miExitClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.XFM}

procedure TForm1.miAboutClick(Sender: TObject);
begin
  RslAbout;
end;

procedure TForm1.rsIniData1SaveToStream(Stream: TStream; var DoStandard: Boolean);
var
  p: PByte;
  i: integer;
begin
  with Stream as TMemoryStream do begin
    p := Memory;
    for i:=0 to Size-1 do begin
      p^ := p^ xor $55; // encrypt all bytes of Stream
      Inc(p);
    end;
  end;
  DoStandard := True; // do standard stream saving
end;

procedure TForm1.rsIniData1LoadFromStream(Stream: TStream; var DoStandard: Boolean);
var
  p: PByte;
  i: integer;
begin
  if FileExists(rsIniData1.FullFileName) then
   with Stream as TMemoryStream do begin
     LoadFromFile(rsIniData1.FullFileName); // load stream manually
     p := Memory;
     for i:=0 to Size-1 do begin
       p^ := p^ xor $55; // decrypt all bytes of Stream
       Inc(p);
     end;
   end;
  DoStandard := False; // disable standard file loading, we are load this file above
end;

procedure TForm1.miExitClick(Sender: TObject);
begin
  Close;
end;

end.
