unit UMain;

interface

uses
  Classes, QForms, QMenus, QTypes, QStdCtrls, QControls, QExtCtrls,
  QrsStorage, QrsPropSaver, QrsIniData, QrsUtils;

type
  TFormMain = class(TForm)
    rsStorage1: TrsStorage;
    rsIniData1: TrsIniData;
    rsPropSaver1: TrsPropSaver;
    MainMenu: TMainMenu;
    miFile: TMenuItem;
    miHelp: TMenuItem;
    miAbout: TMenuItem;
    miSeparator: TMenuItem;
    miExit: TMenuItem;
    Memo1: TMemo;
    pnlTop: TPanel;
    edSample: TEdit;
    lblSample: TLabel;
    procedure miAboutClick(Sender: TObject);
    procedure miExitClick(Sender: TObject);
    procedure edSampleChange(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    FSample: string;
    { Private declarations }
  public
    { Public declarations }
  published
    property Sample: string read FSample write FSample;
  end;

var
  FormMain: TFormMain;

implementation

{$R *.XFM}

procedure TFormMain.miAboutClick(Sender: TObject);
begin
  RslAbout;
end;

procedure TFormMain.miExitClick(Sender: TObject);
begin
  Close;
end;

procedure TFormMain.edSampleChange(Sender: TObject);
begin
  Sample := edSample.Text;
end;

procedure TFormMain.FormActivate(Sender: TObject);
begin
  edSample.Text := Sample;
end;

end.
