# Hey Emacs, this is a -*- Makefile -*-
# ---------------------------------------------------------------------------
ifndef BCB
BCB = /usr/local/kylix3

endif

# ---------------------------------------------------------------------------
# IDE SECTION
# ---------------------------------------------------------------------------
# The following section of the project makefile is managed by the BCB IDE.
# It is recommended to use the IDE to change any of the values in this
# section.
# ---------------------------------------------------------------------------

VERSION = BCB.06.10
# ---------------------------------------------------------------------------
PROJECT = ./bplrsl.so.3.0
OBJFILES = ./QrsStorage.o ./QrsBinData.o ./QrsConst.o \
    ./QrsIniData.o ./QrsPropSaver.o ./QrsProperties.o \
    ./QrsProperty.o ./QrsUtils.o ./QrsXmlData.o \
    ./QrsTreeViewConnector.o ./QrsListViewConnector.o \
    ./QrsXorEncryptor.o ./QdsrAES.o \
    ./QrsAesEncryptor.o ./QrsSearch.o
RESFILES = rsl.res
MAINSOURCE = rsl.bpf
RESDEPEN = $(RESFILES)
LIBFILES = 
IDLFILES = 
IDLGENFILES = 
LIBRARIES = 
PACKAGES = rtl.bpi vcl.bpi visualclx.bpi
SPARELIBS = 
DEFFILE = 
OTHERFILES = 
# ---------------------------------------------------------------------------
PATHCPP = .;
PATHASM = .;
PATHPAS = .;../Source
PATHRC = .;
DEBUGLIBPATH = $(BCB)/lib/debug
RELEASELIBPATH = $(BCB)/lib/release
USERDEFINES = _DEBUG
SYSDEFINES = USEPACKAGES:_RTLDLL
INCLUDEPATH = ../Source:$(BCB)/include/stlport:$(BCB)/include:$(BCB)/include/vcl:/usr/include
LIBPATH = ../Source:$(BCB)/lib/obj:$(BCB)/lib:/usr/lib:/lib:/usr/X11R6/lib:$(BCB)/bin
WARNINGS= -w-par
PATHOBJ = .:$(LIBPATH)
# ---------------------------------------------------------------------------
CFLAG1 = -tP -VP -Od -H=$(HOME)/.borland/clx69.csm -Hc -Vx -Ve -X- -r- -a8 -b- -k \
    -y -v -vi- -c
IDLCFLAGS = 
PFLAGS = -N2. -N0. -P -$$$$YD -$$$$W -$$$$O- -$$$$A8 -v -JPHNE -M -Q
RFLAGS = 
AFLAGS = /mx /w2 /zd
LFLAGS = -l./ -I. -GB"rsl" -N"" -D"" -aa -Tpp -Gpr -x -Gn -Gl -Gi -v
# ---------------------------------------------------------------------------
ALLOBJ = borinitpkg.o $(PACKAGES) $(OBJFILES)
ALLRES = $(RESFILES)
ALLLIB = rtle_pic.a $(LIBFILES) $(LIBRARIES) libborcrtl.so libborstl.so \
    libborunwind.so libpthread.so libdl.so libX11.so libc.so libm.so
# ---------------------------------------------------------------------------
ifneq "$(USERDEFINES)" ""
AUSERDEFINES = -d$(USERDEFINES:= -d)
else
AUSERDEFINES =
endif

ifndef BCC
BCC = $(BCB)/bin/bc++
endif

ifndef CPP
CPP = $(BCB)/bin/bcpp
endif

ifndef DCC
DCC = $(BCB)/bin/dcc
endif

ifndef LINKER
LINKER = $(BCB)/bin/ilink
endif



# ---------------------------------------------------------------------------
ifdef PATHCPP
PATHC   = $(PATHCPP)
else
PATHCPP = $(BCB)/bin
PATHC = $(BCB)/bin
endif

ifndef PATHPAS
PATHPAS = $(BCB)/bin
endif

ifndef PATHASM
PATHASM = $(BCB)/bin
endif

vpath %.o $(PATHOBJ)

ifdef IDEOPTIONS
[Debugging]
DebugSourceDirs=$(BCB)/source/clx
endif




# ---------------------------------------------------------------------------
# MAKE SECTION
# ---------------------------------------------------------------------------
# This section of the project file is not used by the BCB IDE.  It is for
# the benefit of building from the command-line using the MAKE utility.
# ---------------------------------------------------------------------------
$(PROJECT): $(OTHERFILES) $(IDLGENFILES) $(OBJFILES) $(RESDEPEN) $(DEFFILE)
	$(LINKER) \
	$(LFLAGS) -L$(LIBPATH) \
	$(ALLOBJ), \
	$(PROJECT),, \
	$(ALLLIB), \
	$(DEFFILE), \
	$(ALLRES)

# ---------------------------------------------------------------------------
%.hpp: %.pas
	$(DCC) $(PFLAGS) -U$(INCLUDEPATH) -D$(USERDEFINES) -D$(SYSDEFINES) -O$(INCLUDEPATH) --BCB $< 

%.o: %.pas
	$(DCC) $(PFLAGS) -U$(INCLUDEPATH) -D$(USERDEFINES) -D$(SYSDEFINES) -O$(INCLUDEPATH) --BCB $< 

%.o: %.cpp
	$(BCC) $(CFLAG1) $(WARNINGS) -I$(INCLUDEPATH) -D$(USERDEFINES) -D$(SYSDEFINES) -n$(@D) $< 

%.o: %.c
	$(BCC) $(CFLAG1) $(WARNINGS) -I$(INCLUDEPATH) -D$(USERDEFINES) -D$(SYSDEFINES) -n$(@D) $< 

%.i: %.c
	$(CPP) $(CFLAG1) $(WARNINGS) -I$(INCLUDEPATH) -D$(USERDEFINES) -D$(SYSDEFINES) -n. $< 


%.i: %.cpp
	$(CPP) $(CFLAG1) $(WARNINGS) -I$(INCLUDEPATH) -D$(USERDEFINES) -D$(SYSDEFINES) -n. $< 



# ---------------------------------------------------------------------------



