// Borland C++ Builder
// Copyright (c) 1995, 2002 by Borland Software Corporation
// All rights reserved

// (DO NOT EDIT: machine generated header) 'QdsrAES.pas' rev: 6.00

#ifndef QdsrAESHPP
#define QdsrAESHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <Classes.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Qdsraes
{
//-- type declarations -------------------------------------------------------
typedef Byte Word8;

typedef Byte *PWord8;

typedef unsigned Word32;

typedef unsigned *PWord32;

typedef Byte TBlockWord8[16];

typedef Byte *PBlockWord8;

typedef Byte TArrayWord8[32];

typedef Byte *PArrayWord8;

typedef unsigned TArrayWord32[60];

typedef unsigned *PArrayWord32;

#pragma option push -b-
enum TAESChipherMode { cmECB, cmCBC };
#pragma option pop

#pragma option push -b-
enum TAESChipherKeyBits { ck128, ck192, ck256 };
#pragma option pop

class DELPHICLASS TAESChipher;
class PASCALIMPLEMENTATION TAESChipher : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	AnsiString FKey;
	TAESChipherKeyBits FKeyBits;
	TAESChipherMode FMode;
	int Nr;
	unsigned FEncryptRK[60];
	unsigned FDecryptRK[60];
	void __fastcall SetKey(const AnsiString Value);
	void __fastcall SetKeyBits(const TAESChipherKeyBits Value);
	
protected:
	bool KeyNeedUpdate;
	int __fastcall GetKeyBitsAsInteger(void);
	void __fastcall UpdateKeyData(bool Forced);
	
public:
	Byte InitVector[16];
	__fastcall TAESChipher(void);
	__property TAESChipherMode Mode = {read=FMode, write=FMode, default=0};
	__property TAESChipherKeyBits KeyBits = {read=FKeyBits, write=SetKeyBits, default=0};
	__property AnsiString Key = {read=FKey, write=SetKey};
	int __fastcall BlocksDecrypt(void * Src, int Count, void * Dest);
	int __fastcall BlocksEncrypt(void * Src, int Count, void * Dest);
	void __fastcall BlockDecryptRounds(PBlockWord8 block, int rounds);
	void __fastcall BlockEncryptRounds(PBlockWord8 block, int rounds);
	int __fastcall BufferDecrypt(void * Src, int SrcCount, void * Dest, int &DestCount);
	int __fastcall BufferEncrypt(void * Src, int SrcCount, void * Dest, int &DestCount);
	int __fastcall StreamDecrypt(Classes::TStream* Src, Classes::TStream* Dest);
	int __fastcall StreamEncrypt(Classes::TStream* Src, Classes::TStream* Dest);
	AnsiString __fastcall StringDecrypt(const AnsiString Value);
	AnsiString __fastcall StringEncrypt(const AnsiString Value);
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TAESChipher(void) { }
	#pragma option pop
	
};


//-- var, const, procedure ---------------------------------------------------
static const Shortint MAXROUNDS = 0xe;
static const Shortint AESCIPHER_NO_DATA = 0xffffffff;
static const Shortint AESCIPHER_NO_DEST = 0xfffffffe;
static const Shortint AESCIPHER_NEED_MORE_DEST_SIZE = 0xfffffffd;
static const Shortint AESCIPHER_BAD_DATASIZE = 0xfffffffc;

}	/* namespace Qdsraes */
using namespace Qdsraes;
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// QdsrAES
