// Borland C++ Builder
// Copyright (c) 1995, 2002 by Borland Software Corporation
// All rights reserved

// (DO NOT EDIT: machine generated header) 'QrsStorage.pas' rev: 6.00

#ifndef QrsStorageHPP
#define QrsStorageHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <QrsConst.hpp>	// Pascal unit
#include <Variants.hpp>	// Pascal unit
#include <Types.hpp>	// Pascal unit
#include <SyncObjs.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------
#pragma pack(push, 4)
struct TrsKeyValue
{
 Word Options;
 Word kvType;
 union
  {
   void *VPointer;
   void *VBuffer;
   void *VString;
   struct { LONG X; LONG Y; };
   void *VUnknown;
   BOOL VBoolean;
   System::TDateTimeBase VDateTime;
   System::CurrencyBase VCurrency;
   double VDouble;
   __int64 VInt64;
   int VInteger;
   };
};
#pragma pack(pop)
#pragma pack(push, 4)
struct TrsClientItem
{
 bool Exists;
 int Count;
 int Capacity;
 void * *Data;
};
#pragma pack(pop)

namespace Qrsstorage
{
//-- type declarations -------------------------------------------------------
#pragma pack(push, 4)
struct TrsSectionItem
{
	WideString Name;
	int Id;
	int ParentId;
} ;
#pragma pack(pop)

typedef TrsSectionItem *PrsSectionItem;

typedef TrsSectionItem TrsSectionItemList[16384];

typedef TrsSectionItem *PrsSectionItemList;

typedef TrsKeyValue *PrsKeyValue;

struct TrsKeyItem
{
	WideString Name;
	int SectionId;
	TrsKeyValue Value;
} ;

typedef TrsKeyItem *PrsKeyItem;

typedef TrsKeyValue TrsKeyValueList[16384];

typedef TrsKeyValue *PrsKeyValueList;

typedef TrsKeyItem TrsKeyItemList[16384];

typedef TrsKeyItem *PrsKeyItemList;

#pragma option push -b-
enum TrsStorageOption { soSaveOnClose, soSaveEmptySection };
#pragma option pop

typedef Set<TrsStorageOption, soSaveOnClose, soSaveEmptySection>  TrsStorageOptions;

#pragma option push -b-
enum TrsIniCompactOption { coHexStr };
#pragma option pop

typedef Set<TrsIniCompactOption, coHexStr, coHexStr>  TrsIniCompactOptions;

class DELPHICLASS TrsKeyWrapper;
class DELPHICLASS TrsStorage;
class DELPHICLASS TrsStorageData;
typedef void __fastcall (__closure *TrsStorageDataProgressEvent)(System::TObject* Sender, int Percent);

class PASCALIMPLEMENTATION TrsStorageData : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	Classes::TList* FStorageList;
	int FCurrentStorageIdx;
	Classes::TNotifyEvent FOnBeforeSave;
	Classes::TNotifyEvent FOnAfterLoad;
	Classes::TNotifyEvent FOnAfterSave;
	Classes::TNotifyEvent FOnBeforeLoad;
	TrsStorageDataProgressEvent FOnProgress;
	int FPreviousPercent;
	void __fastcall SetStorage(TrsStorage* AStorage);
	void __fastcall UnlinkStorage(TrsStorage* AStorage);
	TrsStorage* __fastcall GetStorage(void);
	
protected:
	int ProgressItemCount;
	int ProgressItemCurrent;
	virtual void __fastcall DoProgress(void);
	virtual void __fastcall InternalLoad(void);
	virtual void __fastcall InternalSave(void);
	virtual void __fastcall Notification(Classes::TComponent* AComponent, Classes::TOperation Operation);
	
public:
	__fastcall virtual TrsStorageData(Classes::TComponent* AOwner);
	__fastcall virtual ~TrsStorageData(void);
	void __fastcall Load(void);
	void __fastcall Save(void);
	__property TrsStorage* Storage = {read=GetStorage};
	
__published:
	__property Classes::TNotifyEvent OnAfterLoad = {read=FOnAfterLoad, write=FOnAfterLoad};
	__property Classes::TNotifyEvent OnAfterSave = {read=FOnAfterSave, write=FOnAfterSave};
	__property Classes::TNotifyEvent OnBeforeLoad = {read=FOnBeforeLoad, write=FOnBeforeLoad};
	__property Classes::TNotifyEvent OnBeforeSave = {read=FOnBeforeSave, write=FOnBeforeSave};
	__property TrsStorageDataProgressEvent OnProgress = {read=FOnProgress, write=FOnProgress};
};


class DELPHICLASS TrsSectionWrapper;
class PASCALIMPLEMENTATION TrsSectionWrapper : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	TrsStorage* FStorage;
	int FSectionIndex;
	int __fastcall GetId(void);
	WideString __fastcall GetName(void);
	int __fastcall GetParentId(void);
	WideString __fastcall GetFullName(void);
	void __fastcall SetSectionIndex(const int Value);
	int __fastcall GetLevel(void);
	
protected:
	TrsSectionItem *PSectionItem;
	__property int SectionIndex = {read=FSectionIndex, write=SetSectionIndex, nodefault};
	
public:
	__fastcall TrsSectionWrapper(TrsStorage* AOwner);
	__fastcall virtual ~TrsSectionWrapper(void);
	__property WideString Name = {read=GetName};
	__property WideString FullName = {read=GetFullName};
	__property int Level = {read=GetLevel, nodefault};
	__property int Id = {read=GetId, nodefault};
	__property int ParentId = {read=GetParentId, nodefault};
};


typedef void __fastcall (__closure *TrsStorageKeyEvent)(System::TObject* Sender, const WideString Key);

class DELPHICLASS TrsClientList;
class DELPHICLASS TrsStorageClient;
#pragma option push -b-
enum TrsClientNotification { scnNone, scnClear, scnLoad, scnSectionAdd, scnSectionDelete, scnSectionModify, scnSectionClear, scnRootSectionChanged, scnKeyAdd, scnKeyDelete, scnKeyModify, scnKeyValueModify };
#pragma option pop

class PASCALIMPLEMENTATION TrsClientList : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	Classes::TList* FList;
	TrsClientItem FItems[12];
	bool FActive;
	TrsStorageClient* __fastcall GetClient(int Index);
	
protected:
	void __fastcall AddToArray(TrsClientNotification Cn, TrsStorageClient* Instance);
	void __fastcall DeleteFromArray(TrsClientNotification Cn, TrsStorageClient* Instance);
	
public:
	__fastcall TrsClientList(void);
	__fastcall virtual ~TrsClientList(void);
	void __fastcall Clear(void);
	int __fastcall Add(TrsStorageClient* Instance);
	int __fastcall IndexOf(TrsStorageClient* Instance);
	void __fastcall Remove(TrsStorageClient* Instance);
	void __fastcall Delete(int Index);
	int __fastcall Count(void);
	bool __fastcall NotificationExist(const TrsClientNotification Value);
	void __fastcall DoNotification(const TrsClientNotification Value, int WParam, int LParam);
	__property TrsStorageClient* Clients[int Index] = {read=GetClient};
	__property bool Active = {read=FActive, write=FActive, default=1};
};


class DELPHICLASS TrsEncryptor;
class PASCALIMPLEMENTATION TrsEncryptor : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	bool FActive;
	bool FEncryptAll;
	TrsStorage* FStorage;
	Classes::TStrings* FEncryptKeys;
	void __fastcall SetStorage(TrsStorage* AStorage);
	void __fastcall SetActive(const bool Value);
	void __fastcall SetEncryptKeys(const Classes::TStrings* Value);
	
protected:
	virtual void __fastcall Notification(Classes::TComponent* AComponent, Classes::TOperation Operation);
	virtual int __fastcall DecryptBuffer(void * PData, int Count);
	virtual int __fastcall EncryptBuffer(void * PData, int Count);
	virtual int __fastcall CalcDecryptBufferSize(const int SourceCount);
	virtual int __fastcall CalcEncryptBufferSize(const int SourceCount);
	
public:
	__fastcall virtual TrsEncryptor(Classes::TComponent* AOwner);
	__fastcall virtual ~TrsEncryptor(void);
	__property TrsStorage* Storage = {read=FStorage};
	virtual void __fastcall DoDecrypt(void);
	virtual void __fastcall DoDecryptAll(void);
	virtual void __fastcall DoDecryptKey(const WideString Key);
	virtual void __fastcall DoDecryptSection(const WideString Section);
	virtual void __fastcall DoEncrypt(void);
	virtual void __fastcall DoEncryptAll(void);
	virtual void __fastcall DoEncryptKey(const WideString Key);
	virtual void __fastcall DoEncryptSection(const WideString Section);
	
__published:
	__property bool Active = {read=FActive, write=SetActive, default=1};
	__property Classes::TStrings* EncryptKeys = {read=FEncryptKeys, write=SetEncryptKeys};
	__property bool EncryptAll = {read=FEncryptAll, write=FEncryptAll, default=0};
};


class PASCALIMPLEMENTATION TrsStorage : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
public:
	Variant operator[](WideString Key) { return Values[Key]; }
	
private:
	bool FActive;
	WideString FCacheSectionName;
	int FCacheSectionIdx;
	int FCacheSectionId;
	WideString FCacheKeyName;
	int FCacheKeyIdx;
	int FCacheKeySectionId;
	TrsKeyItem *FKeyList;
	int FKeyCapacity;
	int FKeyCount;
	int FKeyBeginIdx;
	int FKeyEndIdx;
	int FKeyIndex;
	bool FLazyActive;
	Classes::TNotifyEvent FOnAfterLoad;
	Classes::TNotifyEvent FOnAfterSave;
	Classes::TNotifyEvent FOnBeforeLoad;
	Classes::TNotifyEvent FOnBeforeSave;
	TrsStorageOptions FOptions;
	WideString FRootSection;
	TrsStorageData* FStorageData;
	int FPreferStartSection;
	TrsSectionItem *FSectionList;
	int FSectionCapacity;
	int FSectionCount;
	int FSectionMaxId;
	int FSectionIdx;
	int FSectionChildBeginIdx;
	int FSectionChildEndIdx;
	TrsSectionWrapper* FSectionWrapper;
	int FSectionIndex;
	TrsKeyWrapper* FKeyWrapper;
	TrsStorageKeyEvent FOnKeyDeletion;
	TrsClientList* FClientList;
	TrsStorageKeyEvent FOnKeyAdd;
	TrsEncryptor* FEncryptor;
	Syncobjs::TCriticalSection* FLock;
	Variant __fastcall GetValue(const WideString Key);
	void __fastcall SetActive(const bool Value);
	void __fastcall SetRootSection(const WideString Value);
	void __fastcall SetStorageData(const TrsStorageData* Value);
	void __fastcall SetValue(const WideString Key, const Variant &Value);
	void __fastcall StorageLinkDestroying(void);
	void __fastcall rsGlobalComponentProc(Classes::TComponent* Instance);
	int __fastcall GetKeyType(const WideString Key);
	void __fastcall SetKeyType(const WideString Key, const int Value);
	Word __fastcall GetKeyOptions(const WideString Key);
	void __fastcall SetKeyOptions(const WideString Key, const Word Value);
	void __fastcall DoEncrypt(void);
	void __fastcall DoDecrypt(void);
	AnsiString __fastcall GetVersion(void);
	void __fastcall SetEncryptor(const TrsEncryptor* Value);
	
protected:
	void __fastcall SectionChildCorrectIdxIns(const int Idx);
	void __fastcall SectionChildCorrectIdxDel(const int Idx);
	int __fastcall SectionCurrentId(void);
	bool __fastcall SectionItemInsert(const int Index, const int Count);
	bool __fastcall SectionItemDelete(const int Index, const int Count);
	void __fastcall SectionSetCapacity(const int Value);
	int __fastcall SectionFind(const WideString Section, const bool CanAdd);
	int __fastcall SectionFindIdxEx(const int ParentId, WideString Section);
	int __fastcall SectionFindById(int RngBegin, int RngEnd, const int Id);
	bool __fastcall SectionFindRange(const int ParentId, int &RngBegin, int &RngEnd);
	void __fastcall SectionChildDel(const int SectionIdx, const bool SelfDelete);
	void __fastcall SectionListGrow(const int MinDelta);
	WideString __fastcall SectionFullName(int Idx);
	int __fastcall SectionLevel(int Idx);
	int __fastcall SubSectionAddEx(const int ParentId, WideString Section);
	void __fastcall RecursionSectionSaveToStream(const int SectionId, Classes::TStream* Stream);
	void __fastcall RecursionSectionLoadFromStream(Classes::TStream* Stream);
	DYNAMIC void __fastcall KeyOnDeletion(const int Idx);
	DYNAMIC void __fastcall KeyOnAdd(const int Idx);
	void __fastcall KeyCorrectIdxIns(const int Idx);
	void __fastcall KeyCorrectIdxDel(const int Idx);
	bool __fastcall KeyItemInsert(const int Index, const int Count);
	bool __fastcall KeyItemDelete(const int Index, const int Count);
	void __fastcall KeySetCapacity(const int Value);
	int __fastcall KeyFindIdx(int RngBegin, int RngEnd, const int SectionId, const WideString Key);
	int __fastcall KeyAdd(int RngBegin, int RngEnd, const int SectionId, const WideString Key);
	void __fastcall KeyValueFinalize(const int Idx, const bool WithName);
	void __fastcall KeyListGrow(const int MinDelta);
	bool __fastcall KeyFindRange(const int SectionId, int &RngBegin, int &RngEnd);
	int __fastcall KeyFindAddItem(const WideString Key, const bool CanAdd);
	PrsKeyItem __fastcall GetKeyItem(const int Idx);
	PrsSectionItem __fastcall GetSectionItem(const int Idx);
	bool __fastcall GetKeyRange(int &RangeBegin, int &RangeEnd);
	bool __fastcall GetSectionChildRange(int &RangeBegin, int &RangeEnd);
	__property int KeyCountAll = {read=FKeyCount, write=FKeyCount, nodefault};
	__property int SectionCountAll = {read=FSectionCount, write=FSectionCount, nodefault};
	__property int SectionMaxId = {read=FSectionMaxId, write=FSectionMaxId, nodefault};
	virtual void __fastcall Loaded(void);
	virtual void __fastcall Notification(Classes::TComponent* AComponent, Classes::TOperation Operation);
	
public:
	__fastcall virtual TrsStorage(Classes::TComponent* AOwner);
	__fastcall virtual ~TrsStorage(void);
	void __fastcall Load(void);
	void __fastcall Merge(void);
	void __fastcall Save(void);
	void __fastcall Open(void);
	void __fastcall Close(void);
	void __fastcall Clear(void);
	void __fastcall ClearAll(void);
	bool __fastcall ChangeDownRootSection(const WideString Section);
	bool __fastcall ChangeUpRootSection(void);
	int __fastcall KeyCount(void);
	void __fastcall KeyDelete(const WideString Key);
	bool __fastcall KeyExist(const WideString Key);
	void __fastcall KeyList(Classes::TStrings* Strings);
	void __fastcall KeyRename(const WideString OldName, const WideString NewName);
	__property Word KeyOptions[WideString Key] = {read=GetKeyOptions, write=SetKeyOptions};
	__property int KeyType[WideString Key] = {read=GetKeyType, write=SetKeyType};
	__property TrsKeyWrapper* KeyWrapper = {read=FKeyWrapper};
	int __fastcall KeyFirst(void);
	int __fastcall KeyNext(void);
	int __fastcall KeyPrior(void);
	int __fastcall KeyLast(void);
	void __fastcall Lock(void);
	void __fastcall Unlock(void);
	bool __fastcall SectionAdd(const WideString Section);
	void __fastcall SectionClear(const WideString Section);
	int __fastcall SectionCount(void);
	void __fastcall SectionDelete(const WideString Section);
	bool __fastcall SectionExist(const WideString Section);
	void __fastcall SectionList(Classes::TStrings* Strings);
	WideString __fastcall SectionName(void);
	void __fastcall SectionRename(const WideString OldName, const WideString NewName);
	void __fastcall SectionSaveToStream(const WideString Section, Classes::TStream* Stream);
	void __fastcall SectionLoadFromStream(const WideString Section, Classes::TStream* Stream);
	__property TrsSectionWrapper* SectionWrapper = {read=FSectionWrapper};
	int __fastcall SectionFirst(void);
	int __fastcall SectionNext(void);
	int __fastcall SectionPrior(void);
	int __fastcall SectionLast(void);
	int __fastcall ReadArray(const WideString Key, Variant &Values);
	bool __fastcall ReadBoolean(const WideString Key, const bool DefValue);
	int __fastcall ReadBuffer(const WideString Key, void *Buffer, const int Count);
	Classes::TComponent* __fastcall ReadComponent(const WideString Key, Classes::TComponent* Instance);
	System::Currency __fastcall ReadCurrency(const WideString Key, const System::Currency DefValue);
	System::TDateTime __fastcall ReadDateTime(const WideString Key, const System::TDateTime DefValue);
	double __fastcall ReadFloat(const WideString Key, const double DefValue);
	__int64 __fastcall ReadInt64(const WideString Key, const __int64 DefValue);
	int __fastcall ReadInteger(const WideString Key, const int DefValue);
	bool __fastcall ReadPersistent(const WideString Key, Classes::TPersistent* Instance);
	Types::TPoint __fastcall ReadPoint(const WideString Key);
	void * __fastcall ReadPointer(const WideString Key, const void * DefValue);
	int __fastcall ReadStream(const WideString Key, Classes::TStream* Stream);
	WideString __fastcall ReadString(const WideString Key, const WideString DefValue);
	AnsiString __fastcall ReadText(const WideString Key, const AnsiString DefValue);
	void __fastcall WriteArray(const WideString Key, const Variant &Values);
	void __fastcall WriteBoolean(const WideString Key, const bool Value);
	void __fastcall WriteBuffer(const WideString Key, const void *Buffer, const int Count);
	void __fastcall WriteComponent(const WideString Key, Classes::TComponent* Instance);
	void __fastcall WriteCurrency(const WideString Key, const System::Currency Value);
	void __fastcall WriteDateTime(const WideString Key, const System::TDateTime Value);
	void __fastcall WriteFloat(const WideString Key, const double Value);
	void __fastcall WriteInt64(const WideString Key, const __int64 Value);
	void __fastcall WriteInteger(const WideString Key, const int Value);
	void __fastcall WritePersistent(const WideString Key, Classes::TPersistent* Instance);
	void __fastcall WritePoint(const WideString Key, const Types::TPoint &Point);
	void __fastcall WritePointer(const WideString Key, const void * Value);
	void __fastcall WriteStream(const WideString Key, Classes::TStream* Stream);
	void __fastcall WriteString(const WideString Key, const WideString Value);
	void __fastcall WriteText(const WideString Key, const AnsiString Value);
	__property Variant Values[WideString Key] = {read=GetValue, write=SetValue/*, default*/};
	__property AnsiString Version = {read=GetVersion};
	
__published:
	__property bool Active = {read=FActive, write=SetActive, nodefault};
	__property TrsEncryptor* Encryptor = {read=FEncryptor, write=SetEncryptor};
	__property TrsStorageData* StorageData = {read=FStorageData, write=SetStorageData};
	__property WideString RootSection = {read=FRootSection, write=SetRootSection};
	__property TrsStorageOptions Options = {read=FOptions, write=FOptions, default=1};
	__property Classes::TNotifyEvent OnAfterLoad = {read=FOnAfterLoad, write=FOnAfterLoad};
	__property Classes::TNotifyEvent OnAfterSave = {read=FOnAfterSave, write=FOnAfterSave};
	__property Classes::TNotifyEvent OnBeforeLoad = {read=FOnBeforeLoad, write=FOnBeforeLoad};
	__property Classes::TNotifyEvent OnBeforeSave = {read=FOnBeforeSave, write=FOnBeforeSave};
	__property TrsStorageKeyEvent OnKeyAdd = {read=FOnKeyAdd, write=FOnKeyAdd};
	__property TrsStorageKeyEvent OnKeyDeletion = {read=FOnKeyDeletion, write=FOnKeyDeletion};
};


class PASCALIMPLEMENTATION TrsKeyWrapper : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	TrsStorage* FStorage;
	int FCacheSectionIdx;
	Classes::TMemoryStream* FMemStream;
	Word __fastcall GetKeyType(void);
	void __fastcall SetKeyType(const Word Value);
	Word __fastcall GetKeyOptions(void);
	void __fastcall SetKeyOptions(const Word Value);
	WideString __fastcall GetName(void);
	WideString __fastcall GetSectionName(void);
	WideString __fastcall GetSectionFullName(void);
	int __fastcall GetSectionLevel(void);
	
protected:
	void __fastcall TempClassesActive(const bool Value);
	int __fastcall SectionIndex(void);
	bool __fastcall GetAsBoolean(void);
	System::Currency __fastcall GetAsCurrency(void);
	System::TDateTime __fastcall GetAsDateTime(void);
	double __fastcall GetAsFloat(void);
	__int64 __fastcall GetAsInt64(void);
	int __fastcall GetAsInteger(void);
	Types::TPoint __fastcall GetAsPoint(void);
	void * __fastcall GetAsPointer(void);
	WideString __fastcall GetAsString(void);
	Variant __fastcall GetAsVariant(void);
	void __fastcall SetAsBoolean(const bool Value);
	void __fastcall SetAsCurrency(const System::Currency Value);
	void __fastcall SetAsDateTime(const System::TDateTime Value);
	void __fastcall SetAsFloat(const double Value);
	void __fastcall SetAsInt64(const __int64 Value);
	void __fastcall SetAsInteger(const int Value);
	void __fastcall SetAsPoint(const Types::TPoint &Value);
	void __fastcall SetAsPointer(const void * Value);
	void __fastcall SetAsString(const WideString Value);
	void __fastcall SetAsVariant(const Variant &Value);
	
public:
	TrsKeyItem *PKeyItem;
	__fastcall TrsKeyWrapper(TrsStorage* AOwner);
	__fastcall virtual ~TrsKeyWrapper(void);
	void __fastcall Clear(void);
	void __fastcall AssignValueTo(PrsKeyValue PKey);
	void __fastcall AssignValue(PrsKeyValue PKey);
	int __fastcall GetAsArray(Variant &Values);
	int __fastcall GetAsBuffer(void *Buffer, const int Count);
	int __fastcall GetAsStream(Classes::TStream* Stream);
	void __fastcall GetComponentProps(Classes::TComponent* Instance);
	bool __fastcall GetPersistentProps(Classes::TPersistent* Instance);
	void __fastcall SetAsArray(const Variant &Values);
	void __fastcall SetAsBuffer(const void *Buffer, const int Count);
	void __fastcall SetAsStream(Classes::TStream* Stream);
	Classes::TComponent* __fastcall SetComponentProps(Classes::TComponent* Instance);
	bool __fastcall SetPersistentProps(Classes::TPersistent* Instance);
	__property bool AsBoolean = {read=GetAsBoolean, write=SetAsBoolean, nodefault};
	__property System::Currency AsCurrency = {read=GetAsCurrency, write=SetAsCurrency};
	__property System::TDateTime AsDateTime = {read=GetAsDateTime, write=SetAsDateTime};
	__property double AsFloat = {read=GetAsFloat, write=SetAsFloat};
	__property __int64 AsInt64 = {read=GetAsInt64, write=SetAsInt64};
	__property int AsInteger = {read=GetAsInteger, write=SetAsInteger, nodefault};
	__property Types::TPoint AsPoint = {read=GetAsPoint, write=SetAsPoint};
	__property void * AsPointer = {read=GetAsPointer, write=SetAsPointer};
	__property WideString AsString = {read=GetAsString, write=SetAsString};
	__property Variant AsVariant = {read=GetAsVariant, write=SetAsVariant};
	__property Word KeyType = {read=GetKeyType, write=SetKeyType, nodefault};
	__property Word KeyOptions = {read=GetKeyOptions, write=SetKeyOptions, nodefault};
	__property WideString Name = {read=GetName};
	__property WideString SectionName = {read=GetSectionName};
	__property WideString SectionFullName = {read=GetSectionFullName};
	__property int SectionLevel = {read=GetSectionLevel, nodefault};
	__property TrsStorage* Storage = {read=FStorage, write=FStorage};
};


typedef void __fastcall (__closure *TrsStreamEvent)(Classes::TStream* Stream, bool &DoStandard);

#pragma option push -b-
enum TrsStreamDataOption { doAutoName, doAutoCreateDir };
#pragma option pop

typedef Set<TrsStreamDataOption, doAutoName, doAutoCreateDir>  TrsStreamDataOptions;

#pragma option push -b-
enum TrsStreamFileDir { fdCustom, fdApplication };
#pragma option pop

#pragma option push -b-
enum TrsInternalFileLoad { iflNone, iflAlways, iflNoRealFile };
#pragma option pop

class DELPHICLASS TrsStreamData;
class PASCALIMPLEMENTATION TrsStreamData : public TrsStorageData 
{
	typedef TrsStorageData inherited;
	
private:
	Classes::TMemoryStream* FInternalFile;
	AnsiString FFileName;
	TrsStreamDataOptions FOptions;
	TrsStreamEvent FOnLoadFromStream;
	TrsStreamEvent FOnSaveToStream;
	Classes::TMemoryStream* FStream;
	TrsStreamFileDir FFileDir;
	bool FUnicode;
	AnsiString FInternalFileName;
	TrsInternalFileLoad FInternalFileLoad;
	void __fastcall SetFileDir(const TrsStreamFileDir Value);
	void __fastcall SetOptions(const TrsStreamDataOptions Value);
	void __fastcall SetFileName(const AnsiString Value);
	void __fastcall SetInternalFileName(const AnsiString Value);
	
protected:
	char Buffer[4096];
	int BufferStart;
	AnsiString FExtension;
	AnsiString FHexStrSeparator;
	Classes::TStream* FCurStream;
	void __fastcall BufferClear(void);
	void __fastcall BufferFlush(void);
	void __fastcall BufferWrite(const void *Buf, int Count);
	void __fastcall BufferWriteFmt(const int MaxLength, const AnsiString Fmt, const System::TVarRec * Args, const int Args_Size);
	void __fastcall BufferWriteStr(const AnsiString Value);
	void __fastcall BufferWriteEOL(void);
	void __fastcall BufferWriteStrW(const WideString Value);
	void __fastcall BufferWriteCharW(const WideChar Value);
	void __fastcall BufferWriteCharsW(const WideChar * Values, const int Values_Size);
	__property bool Unicode = {read=FUnicode, write=FUnicode, default=0};
	void __fastcall CheckCreateDirs(const AnsiString Value);
	AnsiString __fastcall GetFileName(void);
	virtual void __fastcall InternalLoad(void);
	virtual void __fastcall InternalSave(void);
	virtual void __fastcall LoadFromStream(Classes::TStream* Stream);
	virtual void __fastcall SaveToStream(Classes::TStream* Stream);
	virtual void __fastcall DefineProperties(Classes::TFiler* Filer);
	void __fastcall ReadData(Classes::TStream* Stream);
	void __fastcall WriteData(Classes::TStream* Stream);
	
public:
	__fastcall virtual TrsStreamData(Classes::TComponent* AOwner);
	__fastcall virtual ~TrsStreamData(void);
	__property TrsStreamFileDir FileDir = {read=FFileDir, write=SetFileDir, default=1};
	__property AnsiString FileName = {read=FFileName, write=SetFileName};
	__property AnsiString FullFileName = {read=GetFileName};
	__property Classes::TMemoryStream* InternalFile = {read=FInternalFile};
	__property AnsiString InternalFileName = {read=FInternalFileName, write=SetInternalFileName};
	__property TrsInternalFileLoad InternalFileLoad = {read=FInternalFileLoad, write=FInternalFileLoad, default=0};
	__property TrsStreamDataOptions Options = {read=FOptions, write=SetOptions, default=1};
	__property TrsStreamEvent OnLoadFromStream = {read=FOnLoadFromStream, write=FOnLoadFromStream};
	__property TrsStreamEvent OnSaveToStream = {read=FOnSaveToStream, write=FOnSaveToStream};
};


typedef Set<TrsClientNotification, scnNone, scnKeyValueModify>  TrsClientNotifications;

class PASCALIMPLEMENTATION TrsStorageClient : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
protected:
	bool FActive;
	TrsClientNotifications FNotifications;
	TrsStorage* FStorage;
	virtual void __fastcall SetActive(const bool Value);
	virtual void __fastcall SetStorage(const TrsStorage* Value);
	virtual void __fastcall Notification(Classes::TComponent* AComponent, Classes::TOperation Operation);
	virtual void __fastcall rsNotification(const TrsClientNotification Value, int WParam, int LParam);
	
public:
	__fastcall virtual TrsStorageClient(Classes::TComponent* AOwner);
	__property bool Active = {read=FActive, write=SetActive, default=1};
	__property TrsStorage* Storage = {read=FStorage, write=SetStorage};
public:
	#pragma option push -w-inl
	/* TComponent.Destroy */ inline __fastcall virtual ~TrsStorageClient(void) { }
	#pragma option pop
	
};


typedef void *TrsClientItemData[16384];

typedef void * *PrsClientItemData;

typedef TrsClientItem *PrsClientItem;

class DELPHICLASS TrsCompressor;
class PASCALIMPLEMENTATION TrsCompressor : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	bool FActive;
	TrsStorage* FStorage;
	void __fastcall SetActive(const bool Value);
	
protected:
	virtual void __fastcall Notification(Classes::TComponent* AComponent, Classes::TOperation Operation);
	
public:
	__fastcall virtual TrsCompressor(Classes::TComponent* AOwner);
	__fastcall virtual ~TrsCompressor(void);
	__property TrsStorage* Storage = {read=FStorage};
	virtual void __fastcall StreamComress(Classes::TStream* Source, Classes::TStream* Dest);
	virtual void __fastcall StreamDecompress(Classes::TStream* Source, Classes::TStream* Dest);
	virtual bool __fastcall IsCompressed(Classes::TStream* Stream);
	
__published:
	__property bool Active = {read=FActive, write=SetActive, default=1};
};


//-- var, const, procedure ---------------------------------------------------
static const Word cMaxItemCount = 0x4000;
static const Shortint kvtUnknown = 0x0;
static const Shortint kvtString = 0x1;
static const Shortint kvtBuffer = 0x2;
static const Shortint kvtInteger = 0x3;
static const Shortint kvtDouble = 0x4;
static const Shortint kvtCurrency = 0x5;
static const Shortint kvtDateTime = 0x6;
static const Shortint kvtBool = 0x7;
static const Shortint kvtPoint = 0x8;
static const Shortint kvtInt64 = 0x9;
static const Shortint kvtPointer = 0xa;
static const Shortint kvtLastIndex = 0xb;
#define SErrGetKeyValue "Can't read value as %s type."
#define SErrSetKeyValue "Can't write value as %s type."
#define CSectionSeparators (System::Set<char, 0, 255> () << '\x2f' << '\x4f' )

}	/* namespace Qrsstorage */
using namespace Qrsstorage;
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// QrsStorage
