// Borland C++ Builder
// Copyright (c) 1995, 2002 by Borland Software Corporation
// All rights reserved

// (DO NOT EDIT: machine generated header) 'QrsXmlData.pas' rev: 6.00

#ifndef QrsXmlDataHPP
#define QrsXmlDataHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <QrsConst.hpp>	// Pascal unit
#include <QrsStorage.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Qrsxmldata
{
//-- type declarations -------------------------------------------------------
typedef Set<char, 0, 255>  TrsXMLTokenEndChars;

#pragma option push -b-
enum TrsXMLDataOption { doKeyValueInAttribute, doGetTemplateOnLoad };
#pragma option pop

typedef Set<TrsXMLDataOption, doKeyValueInAttribute, doGetTemplateOnLoad>  TrsXMLDataOptions;

#pragma option push -b-
enum TrsXMLCompactOption { coHexStr, coIndent, coEOL };
#pragma option pop

typedef Set<TrsXMLCompactOption, coHexStr, coEOL>  TrsXMLCompactOptions;

class DELPHICLASS TrsXMLData;
class PASCALIMPLEMENTATION TrsXMLData : public Qrsstorage::TrsStreamData 
{
	typedef Qrsstorage::TrsStreamData inherited;
	
private:
	Classes::TStringList* FAttrNames;
	Classes::TStringList* FAttrValues;
	char *PBufStart;
	char *PCur;
	int FCurrentIndention;
	WideString FCurrentRootName;
	WideString FCurrentSectionName;
	Classes::TStrings* FTemplate;
	AnsiString FRootName;
	TrsXMLDataOptions FXMLDataOptions;
	char *FTmplBodyStart;
	char *FTmplBodyStop;
	char *FTmplStart;
	char *FTmplStop;
	TrsXMLCompactOptions FCompactOptions;
	WideString FEOL;
	int FIndentionDelta;
	bool IsUnicode;
	int CharSize;
	void __fastcall SetTemplate(const Classes::TStrings* Value);
	bool __fastcall IsTemplateStored(void);
	Word __fastcall GetNextChar(void);
	Word __fastcall GetCurrChar(void);
	void __fastcall SkipChar(void);
	WideString __fastcall PreviewNextChars(const int Count);
	AnsiString __fastcall EncodeStr(const AnsiString Value);
	AnsiString __fastcall DecodeStr(const AnsiString Value);
	WideString __fastcall EncodeStrW(const WideString Value);
	WideString __fastcall DecodeStrW(const WideString Value);
	Word __fastcall SkipSpaces(void);
	void __fastcall SkipToStr(const AnsiString Value);
	Word __fastcall SkipToChars(const TrsXMLTokenEndChars &LastChars);
	void __fastcall DoEndTag(void);
	void __fastcall DoStartTag(void);
	WideString __fastcall GetToken(const TrsXMLTokenEndChars &LastChars);
	void __fastcall StorageFill(void);
	WideString __fastcall GetValueAsString(Qrsstorage::PrsKeyItem KeyItem);
	void __fastcall WriteFromString(const WideString Key, const WideString Value, const Word Option);
	
protected:
	virtual void __fastcall LoadFromStream(Classes::TStream* Stream);
	virtual void __fastcall SaveToStream(Classes::TStream* Stream);
	void __fastcall SaveSection(void);
	
public:
	__fastcall virtual TrsXMLData(Classes::TComponent* AOwner);
	__fastcall virtual ~TrsXMLData(void);
	__property AnsiString RootName = {read=FRootName, write=FRootName};
	
__published:
	__property Classes::TStrings* Template = {read=FTemplate, write=SetTemplate, stored=IsTemplateStored};
	__property FileName ;
	__property FileDir  = {default=1};
	__property InternalFileName ;
	__property InternalFileLoad  = {default=0};
	__property Options  = {default=1};
	__property TrsXMLDataOptions XMLOptions = {read=FXMLDataOptions, write=FXMLDataOptions, default=0};
	__property Unicode  = {default=0};
	__property TrsXMLCompactOptions CompactOptions = {read=FCompactOptions, write=FCompactOptions, default=0};
	__property OnLoadFromStream ;
	__property OnSaveToStream ;
};


//-- var, const, procedure ---------------------------------------------------
static const Shortint CXMLkoAttribute = 0x1;
static const Shortint CXMLkoValueInAttribute = 0x2;
static const Shortint CXMLkoValueInData = 0x4;
#define SErrXMLEOF "Unexpected end of file."
#define SErrMissingEQ "Missing equality sign."
#define SErrMissingQuote "Missing quotation mark."
#define SErrMissingEndTag "Missing end tag mark."
#define SErrMissingBeginTag "Missing begin tag mark."
#define SErrMissingStr "Missing %s mark."
#define SErrUnknownEntity "Unknown entity."
#define SErrInEntity "No end mark in the entity."

}	/* namespace Qrsxmldata */
using namespace Qrsxmldata;
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// QrsXmlData
