#!/bin/bash
#
# Storage Library install script
# Copyright(C) 2001-2003 Andrei Roofin
# http://www.deepsoftware.ru
# e-mail: ray@deepsoftware.ru
#
#
MSGERROR='ERROR:'
MSGINSTPATH='Please enter Storage Library install path'

KYLIX1CONF='/usr/local/etc/delphi60rc.conf'
KYLIX1CONF2='/root/.borland/delphi60rc'
KYLIX2CONF='/usr/local/etc/delphi65rc.conf'
KYLIX2CONF2='/root/.borland/delphi65rc'
KYLIX3CONF='/usr/local/etc/delphi69rc.conf'
KYLIX3CONF2=$HOME'/.borland/delphi69rc'
KYLIX3BCBCONF='/usr/local/etc/bcb69rc.conf'
KYLIX3BCBCONF2=$HOME'/.borland/bcb69rc'
RSLKYLIX1SRC='/Kylix1'
RSLKYLIX2SRC='/Kylix2'
RSLKYLIX3SRC='/Kylix3'

RSLDCLPACKAGE1='bpldclrsl.so.1.0'
RSLDCLPACKAGE2='bpldclrsl.so.2.0'
RSLDCLPACKAGE3='bpldclrsl.so.3.0'
RSLPACKAGE1='bplrsl.so.1.0'
RSLPACKAGE2='bplrsl.so.2.0'
RSLPACKAGE3='bplrsl.so.3.0'

RSLTAR='rsllib.tar'

function CheckKylix {  
  if [ -e $KYLIXCONF ]; then
    kxroot=`cat $KYLIXCONF |grep "DelphiRoot="`
    kxroot=`echo $kxroot |awk -F. '{printf substr($1,12)}'`
    Chk=0    
  else
    Chk=1
  fi
  return $Chk
}

function DoPath {
  libpath=`grep -A 0 "^Search Path=" $KYLIXCONF2`
  libpath=`echo $libpath |awk -F. '{printf substr($1,13)}'`
  nnn1=':'$rslroot$RSLKYLIXSRC
  libpath=`echo $libpath |awk -F. '{printf gensub("'$nnn1'","","g",$1)}'`
  nnn2=':'$rslroot'/Source'
  libpath=`echo $libpath |awk -F. '{printf gensub("'$nnn2'","","g",$1)}'`
  libpath=$libpath$nnn1$nnn2

  ./Source/iniset "$KYLIXCONF2" "Library" "Search Path" "$libpath"
  ./Source/iniset "$KYLIXCONF2" "Known Packages" "$rslroot$RSLKYLIXSRC/$RSLDCLPACKAGE" "Storage Library (C) Andrei Roofin, DeepSoftware"
  return 1;
}

function BuildPackage {
  cd .$RSLKYLIXSRC
  $kxroot/bin/dcc  -u$kxroot/lib -o$kxroot/bin rsl.dpk -B -Q
  $kxroot/bin/dcc  -u$kxroot/lib -o$kxroot/bin dclrsl.dpk -B -Q
  cp $RSLPACKAGE $kxroot/bin
  cd ..
  DoPath
  return 1;
}

function BuildBCBPackage {
  cd .$RSLKYLIXSRC
    make -f rsl.mak
  cd ..
  DoPath
  return 1;
}



clear
echo "Storage library v3.23 (C) Andrei Roofin, DeepSoftware"
echo 
echo "Welcome to Storage Library setup script."
echo 
echo "Please shutdown all runned Kylix programs before continue"
echo -n "when ready press <Enter>"
read

# -------------------------
# Checking Install File ...

if [ -e $RSLTAR ]; then
  echo  
else
  echo $MSGERROR "Storage Library tar image not found !!! " 
  exit 0
fi

# --------------------------------
# Request the destination path ...

echo $MSGINSTPATH
echo -n '[default path is '$HOME'/Storage]:'
read rslroot
if [ "$rslroot" = "" ]; then 
  rslroot=$HOME'/Storage' 
fi

echo
echo 'Storage Library Home Path will be = '$rslroot
echo
if [ -e $rslroot ]; then
  echo "Copying file ..." 
else
  mkdir $rslroot
fi

# --------------------------------
# Extract TAR file ...

cp -f $RSLTAR $rslroot
cd $rslroot
tar xf $RSLTAR
rm $RSLTAR

# --------------------------------
# Checking Kylix1 
echo
KYLIXCONF=$KYLIX1CONF
KYLIXCONF2=$KYLIX1CONF2
if ! CheckKylix; then
  echo "Kylix 1 not found."
  rm -fr .$RSLKYLIX1SRC
else
  # --------------------------------
  # Build Package for Kylix1 
  echo "Kylix 1 Home Path = "$kxroot 
  echo -n "Install Storage library in Kylix 1? [Y/n]"
  read response
  case $response in
    n*|N* )
       rm -fr .$RSLKYLIX1SRC
       ;;
    * )    
       RSLKYLIXSRC=$RSLKYLIX1SRC
       RSLDCLPACKAGE=$RSLDCLPACKAGE1
       RSLPACKAGE=$RSLPACKAGE1
       BuildPackage
       echo
       ;;
  esac       
fi

# --------------------------------
# Checking Kylix2
echo
KYLIXCONF=$KYLIX2CONF
KYLIXCONF2=$KYLIX2CONF2
if ! CheckKylix; then
  echo "Kylix 2 not found."
  rm -fr .$RSLKYLIX2SRC
else
  # --------------------------------
  # Build Package for Kylix2
  echo "Kylix 2 Home Path = "$kxroot 
  echo -n "Install Storage library in Kylix 2? [Y/n]"
  read response
  case $response in
    n*|N* )
       rm -fr .$RSLKYLIX2SRC
       ;;
    * )    
       RSLKYLIXSRC=$RSLKYLIX2SRC
       RSLDCLPACKAGE=$RSLDCLPACKAGE2
       RSLPACKAGE=$RSLPACKAGE2
       BuildPackage
       echo
       ;;
  esac       
fi

# --------------------------------
# Checking Kylix3
echo
KYLIXCONF=$KYLIX3CONF
KYLIXCONF2=$KYLIX3CONF2
if ! CheckKylix; then
  echo "Kylix 3 not found."
  rm -fr .$RSLKYLIX3SRC
else
  # --------------------------------
  # Build Package for Kylix3
  echo "Kylix 3 Home Path = "$kxroot 
  echo -n "Install Storage library in Kylix 3? [Y/n]"
  read response
  case $response in
    n*|N* )
       rm -fr .$RSLKYLIX3SRC
       ;;
    * )    
       RSLKYLIXSRC=$RSLKYLIX3SRC
       RSLDCLPACKAGE=$RSLDCLPACKAGE3
       RSLPACKAGE=$RSLPACKAGE3

       KYLIXCONF=$KYLIX3BCBCONF
       KYLIXCONF2=$KYLIX3BCBCONF2
       BuildBCBPackage

       KYLIXCONF=$KYLIX3CONF
       KYLIXCONF2=$KYLIX3CONF2
       BuildPackage

       echo
       ;;
  esac       
fi

echo
echo "Installation finished!"
echo
echo "don't forget read readme.txt and license.txt"
echo
echo "Contacts:"
echo "Web:   http://www.deepsoftware.ru/"
echo "e-mail: ray@deepsoftware.ru"
echo ""
echo -n "press <Enter>"

read
